VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form Form1 
   Caption         =   "Multitemporal Block Triangulation with Hybrid Bundle Block Adjustment. Ilkka Korpela Aug-Sept 2000"
   ClientHeight    =   9900
   ClientLeft      =   2295
   ClientTop       =   2460
   ClientWidth     =   15570
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   9900
   ScaleWidth      =   15570
   Begin VB.ListBox List1 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   6990
      Left            =   120
      TabIndex        =   0
      Top             =   2325
      Width           =   14895
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   9120
      Top             =   480
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Menu File 
      Caption         =   "File"
      Begin VB.Menu Open_obs_ini 
         Caption         =   "Open Observation Files and Initial Approximations"
      End
      Begin VB.Menu read_corr_vector 
         Caption         =   "Open correction vector file"
      End
      Begin VB.Menu Output_Solution 
         Caption         =   "Print the unknowns of the problem to a file"
      End
   End
   Begin VB.Menu calculations 
      Caption         =   "Calculations"
      Begin VB.Menu Calculate_normal_matrix 
         Caption         =   "Add correction vector and calculate/output elements of normal Matrix & vector"
      End
      Begin VB.Menu Calculate_Space_intersection 
         Caption         =   "Calculate the object coordinates for the GCPs and errors in them"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private Sub Add_corr_vector_Click()

End Sub

Private Sub Calculate_normal_matrix_Click()

Rem This Routine first updates the unknowns of the iterative adjustment process
Rem by adding the elements of the correction vector to the unknowns,
Rem updates the R-matrices, zeros matrix A (A'A = normal Matrix), then processes
Rem all image observations (rows in A and vector l), updates A and l, prints their
Rem contents to two separate ascii files to be inputted in Matlab for inv(A'A)*A'*l
Rem computation of the correction vector, again to inputted to this program.

Rem ****************'
Rem Feb 2005: Added feature OBSERVATIONS AS UNKNOWNS
Rem
Rem The unknowns (X0,Y0,Z0,omega,phi,kappa) may be known from direct georeferencing
Rem
Rem This information is added to the HYBRID adjustment by adding error equations
Rem weighted by a prioiri stdev of error

Rem Oct 2011 all 3D points are tie points with a priori weights, which are very large
Rem if the points are "tie points"


Open "c:\data\koe.txt" For Output As 1
'Close (1)

Dim dx_domega_K As Double, dy_domega_K As Double, dx_dphi_K As Double
Dim dy_dphi_K As Double, dx_dkappa_K As Double, dy_dkappa_K As Double
Dim dx_dU_K As Double, dy_dU_K As Double, dx_dU0_K As Double
Dim dy_dU0_K As Double, dx_dV_K As Double, dy_dV_K As Double
Dim dx_dV0_K As Double, dy_dV0_K As Double, dx_dW_K As Double
Dim dy_dW_K As Double, dx_dW0_K As Double, dy_dW0_K As Double
Dim dx As Double, dy As Double
Dim obs As Integer, order As Integer
Dim RMSE As Double, max_x As Double, max_y As Double, min_x As Double, min_y As Double

Rem Assign min/max vars (of obervation errors with initial values)
max_x = -1#: max_y = -1#: min_x = 1#: min_y = 1#

' *****************************************************************************
' Add the elements of the correction vector to the initial (approximate) values
' of the unknowns of the problem

Call Add_Correction_vector

' ****************************************************************************
' Recalculate the rotation matrices R(j , 1 x 3, 1 x 3) for all images j

Call Calculate_Rotation_Matrices

Rem Go thru all observations 1,...Num_of_Obs:
Rem For each observation calculate the approximations (for x and y) with the parameters
Rem 'at hand', and subsequent errors (for vector l) and differential quotiens (for matrix A)
Rem For each observation print 2 rows in matrix A of diff. quotiens in correct columns and
Rem add zeros where needed (A is block-diagonal matrix). Alsi print 2 rows in residual-vector l.

ReDim P(1 To (2 * Num_Of_Image_Obs + 6 * Num_Of_GPSIMU + 3 * Num_Of_Tie_Points + 2 * Num_Of_XY_Pairs + Num_Of_Z_Pairs)) As Double

k = 0
For i = 1 To (2 * Num_Of_Image_Obs) Step 2 '  + 6 * Num_Of_GPSIMU + 3 * Num_Of_Tie_Points + 2 * Num_Of_XY_Pairs + Num_Of_Z_Pairs)
 k = k + 1
 P(i) = 1 / (Ima_obs(k).weight ^ 2)
 P(i + 1) = 1 / (Ima_obs(k).weight ^ 2)
Next i
k = 0
For i = (2 * Num_Of_Image_Obs) + 1 To ((2 * Num_Of_Image_Obs) + 6 * Num_Of_GPSIMU) Step 6 '  + 3 * Num_Of_Tie_Points + 2 * Num_Of_XY_Pairs + Num_Of_Z_Pairs)
 k = k + 1
 P(i) = 1 / (Cam_obs(k).womega ^ 2)
 P(i + 1) = 1 / (Cam_obs(k).wphi ^ 2)
 P(i + 2) = 1 / (Cam_obs(k).wkappa ^ 2)
 P(i + 3) = 1 / (Cam_obs(k).wx0 ^ 2)
 P(i + 4) = 1 / (Cam_obs(k).wy0 ^ 2)
 P(i + 5) = 1 / (Cam_obs(k).wz0 ^ 2)
Next i

k = 0
For i = 2 * Num_Of_Image_Obs + 1 + 6 * Num_Of_GPSIMU To 2 * Num_Of_Image_Obs + 6 * Num_Of_GPSIMU + 3 * Num_Of_Tie_Points Step 3    ' + 2 * Num_Of_XY_Pairs + Num_Of_Z_Pairs)
 k = k + 1
 P(i) = 1 / (Gnd_obs(k).wX ^ 2)
 P(i + 1) = 1 / (Gnd_obs(k).WY ^ 2)
 P(i + 2) = 1 / (Gnd_obs(k).WZ ^ 2)
Next i

alku = 2 * Num_Of_Image_Obs + 6 * Num_Of_GPSIMU + 3 * Num_Of_Tie_Points + 1
loppu = alku + 2 * Num_Of_XY_Pairs + Num_Of_Z_Pairs
Rem Weisghts for pairs, not defined here!


Rem CHANGE AUG 22; print A directly (non-zero elements)
Open "C:\data\A_txt.txt" For Output As 11
NofNonZero = 0
For obs = 1 To Num_Of_Image_Obs
 
Call Calculate_Differential_quotiens(obs, dx_domega_K, dy_domega_K, dx_dphi_K, dy_dphi_K, dx_dkappa_K, dy_dkappa_K, dx_dU_K, dy_dU_K, dx_dU0_K, dy_dU0_K, dx_dV_K, dy_dV_K, dx_dV0_K, dy_dV0_K, dx_dW_K, dy_dW_K, dx_dW0_K, dy_dW0_K, dx, dy)
 
Rem Get the COL index for the observation in question, i

For k = 1 To Num_Of_Images
 If Cam_obs(k).image = Ima_obs(obs).image Then
  i = 1 + (k - 1) * 6
  GoTo Image_Found
 End If
Next k
Rem We must find all  If not, notify and exit
MsgBox ("IN Calculate Normal matrix, error finding the right column, i in A")
Exit Sub

Image_Found:
Rem Print the coefficients of the exterior orientation to Matrix A
Rem CHANGE AUG 22 2005; instead of using A, which is vvery large, print non-zero elements directly to a file
Rem x-row

If dx_domega_K <> 0# Then
 Print #11, Format$(2 * obs - 1, "#") & " " & Format$(i, "#") & " " & Format$(dx_domega_K, "#.0000000000000000")
 NofNonZero = NofNonZero + 1
End If
If dx_dphi_K <> 0# Then
 Print #11, Format$(2 * obs - 1, "#") & " " & Format$(i + 1, "#") & " " & Format$(dx_dphi_K, "#.0000000000000000")
 NofNonZero = NofNonZero + 1
End If
If dx_dkappa_K <> 0# Then
 Print #11, Format$(2 * obs - 1, "#") & " " & Format$(i + 2, "#") & " " & Format$(dx_dkappa_K, "#.0000000000000000")
 NofNonZero = NofNonZero + 1
End If
If dx_dU0_K <> 0# Then
 Print #11, Format$(2 * obs - 1, "#") & " " & Format$(i + 3, "#") & " " & Format$(dx_dU0_K, "#.0000000000000000")
 NofNonZero = NofNonZero + 1
End If
If dx_dV0_K <> 0# Then
 Print #11, Format$(2 * obs - 1, "#") & " " & Format$(i + 4, "#") & " " & Format$(dx_dV0_K, "#.0000000000000000")
 NofNonZero = NofNonZero + 1
End If
If dx_dW0_K <> 0# Then
 Print #11, Format$(2 * obs - 1, "#") & " " & Format$(i + 5, "#") & " " & Format$(dx_dW0_K, "#.0000000000000000")
 NofNonZero = NofNonZero + 1
End If


Rem y-row

If dy_domega_K <> 0# Then
 Print #11, Format$(2 * obs, "#") & " " & Format$(i, "#") & " " & Format$(dy_domega_K, "#.0000000000000000")
 NofNonZero = NofNonZero + 1
End If
If dy_dphi_K <> 0# Then
 Print #11, Format$(2 * obs, "#") & " " & Format$(i + 1, "#") & " " & Format$(dy_dphi_K, "#.0000000000000000")
 NofNonZero = NofNonZero + 1
End If
If dy_dkappa_K <> 0# Then
 Print #11, Format$(2 * obs, "#") & " " & Format$(i + 2, "#") & " " & Format$(dy_dkappa_K, "#.0000000000000000")
 NofNonZero = NofNonZero + 1
End If
If dy_dU0_K <> 0# Then
 Print #11, Format$(2 * obs, "#") & " " & Format$(i + 3, "#") & " " & Format$(dy_dU0_K, "#.0000000000000000")
 NofNonZero = NofNonZero + 1
End If
If dy_dV0_K <> 0# Then
 Print #11, Format$(2 * obs, "#") & " " & Format$(i + 4, "#") & " " & Format$(dy_dV0_K, "#.0000000000000000")
 NofNonZero = NofNonZero + 1
End If
If dy_dW0_K <> 0# Then
 Print #11, Format$(2 * obs, "#") & " " & Format$(i + 5, "#") & " " & Format$(dy_dW0_K, "#.0000000000000000")
 NofNonZero = NofNonZero + 1
End If

Rem Print the elements (residuals) in normal vector l
Rem P's defined allready
'P(2 * obs - 1) = 1 / (2) ^ 2  ' X (sarake)
'P(2 * obs) = 1 / (2) ^ 2      ' Y (rivi)

Rem x-row (element)
l(2 * obs - 1) = dx '* 1.090909091
Rem y-row (element)
l(2 * obs) = dy '* 1.090909091

'Open "c:\data\koe.txt" For Append As 5
 Print #1, Cam_obs(k).image, Ima_obs(obs).Point, Ima_obs(obs).x, Ima_obs(obs).y, dx, dy
'Close (5)

RMSE = RMSE + dx ^ 2 + dy ^ 2
If dx > max_x Then max_x = dx
If dx < min_x Then min_x = dx
If dy > max_y Then max_y = dy
If dy < min_y Then min_y = dy

Rem Find the type of the XYZ-point for the observation Ima_obs(obs).Point in question
Rem Type is stored in Gnd_obs(j).Type

Colorder = 0
For j = 1 To (Num_Of_Elev_Points + Num_Of_Tie_Points + Num_Of_GCPS)
 If Gnd_obs(j).Type = 0 Then Colorder = Colorder + 3
 If Gnd_obs(j).Type = 2 Then Colorder = Colorder + 2
 If order > (Num_Of_Tie_Points + Num_Of_Elev_Points) Then MsgBox ("In Calculate_Normal_Matrix order exceeds Num_Of_Tie_POints!")
 If Gnd_obs(j).Point = Ima_obs(obs).Point Then   ' Found
  If Gnd_obs(j).Type = 0 Then GoTo Tie_Point  ' only tie points anymore
 End If
Next j
MsgBox ("In Calculate_normal_matrix there is an obs for which there isn't gnd-data!")

Tie_Point:

Rem A is updated (two subsequent rows) for columns that apply for tie point gnd_obs(j).Point

If dx_dU_K <> 0# Then
  Print #11, Format$(2 * obs - 1, "#") & " " & Format$(6 * Num_Of_Images + Colorder - 2, "#") & " " & Format$(dx_dU_K, "#.0000000000000000")
  NofNonZero = NofNonZero + 1
 End If
If dx_dV_K <> 0# Then
 Print #11, Format$(2 * obs - 1, "#") & " " & Format$(6 * Num_Of_Images + Colorder - 1, "#") & " " & Format$(dx_dV_K, "#.0000000000000000")
  NofNonZero = NofNonZero + 1
End If
If dx_dW_K <> 0# Then
 Print #11, Format$(2 * obs - 1, "#") & " " & Format$(6 * Num_Of_Images + Colorder, "#") & " " & Format$(dx_dW_K, "#.0000000000000000")
  NofNonZero = NofNonZero + 1
End If
If dy_dU_K <> 0# Then
 Print #11, Format$(2 * obs, "#") & " " & Format$(6 * Num_Of_Images + Colorder - 2, "#") & " " & Format$(dy_dU_K, "#.0000000000000000")
 NofNonZero = NofNonZero + 1
End If
If dy_dV_K <> 0# Then
 Print #11, Format$(2 * obs, "#") & " " & Format$(6 * Num_Of_Images + Colorder - 1, "#") & " " & Format$(dy_dV_K, "#.0000000000000000")
 NofNonZero = NofNonZero + 1
End If
If dy_dW_K <> 0# Then
 Print #11, Format$(2 * obs, "#") & " " & Format$(6 * Num_Of_Images + Colorder, "#") & " " & Format$(dy_dW_K, "#.0000000000000000")
  NofNonZero = NofNonZero + 1
End If


GCP_Point:
Rem columns are left zero

Next obs

Rem ********************
Rem Weight Matrix
Rem Collect GPS-eq.
Nsuch = 0
For k = 1 To Num_Of_Images
If Cam_obs(k).Type = 1 Then
   Nsuch = Nsuch + 1
   i = 1 + (k - 1) * 6
   Shift = 2 * Num_Of_Image_Obs
   Row = Shift + (Nsuch - 1) * 6 + 1
  
Print #11, Format$(Row, "#") & " " & Format$(i, "#") & " " & Format$(1, "#.00")
Print #11, Format$(Row + 1, "#") & " " & Format$(i + 1, "#") & " " & Format$(1, "#.00")
Print #11, Format$(Row + 2, "#") & " " & Format$(i + 2, "#") & " " & Format$(1, "#.00")
Print #11, Format$(Row + 3, "#") & " " & Format$(i + 3, "#") & " " & Format$(1, "#.00")
Print #11, Format$(Row + 4, "#") & " " & Format$(i + 4, "#") & " " & Format$(1, "#.00")
Print #11, Format$(Row + 5, "#") & " " & Format$(i + 5, "#") & " " & Format$(1, "#.00")
NofNonZero = NofNonZero + 6
 
Rem Here we weigth the obs, assume 0.000012 mean square error of unit weight
Rem Assume 10 um accuracy for point obs: Pxy weight = (12/10)^2 = 1.44 um^-2
Rem Assume 0.1 m accuracy for X0Y0,Z0 0.01 * Weight = 0.000012
Rem Asuume 0.000045 rad for omega and phi
Rem Assume 0.000072 rad kappa accuracy

 l(Row) = -((Cam_obs(k).omega - Cam_obs(k).omega_IMU)) / 10 ^ 6  ' * 0.137509871
 l(Row + 1) = -((Cam_obs(k).phi - Cam_obs(k).phi_IMU)) / 10 ^ 6  ' * 0.137509871
 l(Row + 2) = -((Cam_obs(k).kappa - Cam_obs(k).kappa_IMU)) / 10 ^ 6  ' * 0.085943669
 l(Row + 3) = -((Cam_obs(k).x0 - Cam_obs(k).X0_GPS)) / 10 ^ 6 '* 0.00012
 l(Row + 4) = -((Cam_obs(k).y0 - Cam_obs(k).Y0_GPS)) / 10 ^ 6 '* 0.00012
 l(Row + 5) = -((Cam_obs(k).z0 - Cam_obs(k).Z0_GPS)) / 10 ^ 6 '* 0.00012
 
End If

Next k ' Next image

' tie points
Shift = Row + 5        ' row shift
Row = Shift + 1

For kx = 1 To Num_Of_Tie_Points Step 1
Rem column
 i = 6 * NumofImages + (kx - 1) * 3 + 1
 l(Row) = -((Gnd_obs(kx).x - Gnd_obs(kx).x_ini)) / 10 ^ 6  ' * 0.137509871
 l(Row + 1) = -((Gnd_obs(kx).y - Gnd_obs(kx).y_ini)) / 10 ^ 6 ' * 0.137509871
 l(Row + 2) = -((Gnd_obs(kx).z - Gnd_obs(kx).z_ini)) / 10 ^ 6 ' * 0.137509871
 
 Print #11, Format$(Row, "#") & " " & Format$(i, "#") & " " & Format$(1, "#.00")
 Print #11, Format$(Row + 1, "#") & " " & Format$(i + 1, "#") & " " & Format$(1, "#.00")
 Print #11, Format$(Row + 2, "#") & " " & Format$(i + 2, "#") & " " & Format$(1, "#.00")
 
 NofNonZero = NofNonZero + 3
 
 Row = Row + 3
Next kx





Rem Z-constrained point pair

 Shift = 2 * Num_Of_Image_Obs         ' row shift
 Row = Shift + 6 * Num_Of_GPSIMU + 3 * Num_Of_Tie_Points     '  "    "
 
 For kx = 1 To Num_Of_Z_Pairs
  Rem Z_pairs(ix (1 to N_of_Z_Pairs).ID_1 holds the point ID
  Rem ColIDPt(ix (1 to N_all_GCP_TIE_ELEV)).Pt_ID holds the point ID and columns for it in A
    ID1 = 0: ID2 = 0
    For mx = 1 To Num_Of_GCPS + Num_Of_Tie_Points + Num_Of_Elev_Points
     If Gnd_obs(mx).Point = Z_pairs(kx).ID_1 Then
       ID1 = mx
       col1 = ColIDPt(mx).Z_ID
     End If
     If Gnd_obs(mx).Point = Z_pairs(kx).ID_2 Then
       ID2 = mx
       col2 = ColIDPt(mx).Z_ID
     End If
    Next mx
    If ID1 = 0 Or ID2 = 0 Then MsgBox ("Cannot find data for Z-constrained tie points")
    l(Row + kx) = (Gnd_obs(ID1).z - Gnd_obs(ID2).z) / 10 ^ 6
    P(Row + kx) = ((1 / (0.001) ^ 2)) '/ 10 ^ 6
    If col1 <> -99 Then
     Print #11, Format$(Row + kx, "#") & " " & Format$(col1, "#") & " " & Format$(-1, "#.00")
     NofNonZero = NofNonZero + 1
    End If
    If col2 <> -99 Then
     Print #11, Format$(Row + kx, "#") & " " & Format$(col2, "#") & " " & Format$(1, "#.00")
     NofNonZero = NofNonZero + 1
    End If
  Next kx
 
 Row = Shift + 6 * Num_Of_GPSIMU + Num_Of_Z_Pairs

 Rem Constrained Xs in XY-pairs
 For kx = 1 To Num_Of_XY_Pairs
  Rem XY_pairs(ix (1 to N_of_Z_Pairs).ID_1 holds the point ID
  Rem ColIDPt(ix (1 to N_all_GCP_TIE_ELEV)).Pt_ID holds the point ID and columns for it in A
    ID1 = 0: ID2 = 0
    For mx = 1 To Num_Of_GCPS + Num_Of_Tie_Points + Num_Of_Elev_Points
     If Gnd_obs(mx).Point = XY_pairs(kx).ID_1 Then
       ID1 = mx
       col1 = ColIDPt(mx).X_ID
     End If
     If Gnd_obs(mx).Point = XY_pairs(kx).ID_2 Then
       ID2 = mx
       col2 = ColIDPt(mx).X_ID
     End If
    Next mx
    If ID1 = 0 Or ID2 = 0 Then MsgBox ("Cannot find data for XY-constrained tie points")
    l(Row + kx) = (Gnd_obs(ID1).x - Gnd_obs(ID2).x) / 10 ^ 6
    P(Row + kx) = ((1 / (0.001) ^ 2)) '/ 10 ^ 6
    Print #11, Format$(Row + kx, "#") & " " & Format$(col1, "#") & " " & Format$(-1, "#.00")
    Print #11, Format$(Row + kx, "#") & " " & Format$(col2, "#") & " " & Format$(1, "#.00")
    NofNonZero = NofNonZero + 2
  Next kx

Row = Shift + 6 * Num_Of_GPSIMU + Num_Of_Z_Pairs + Num_Of_XY_Pairs
Rem Constrained XY in XY-pairs
 For kx = 1 To Num_Of_XY_Pairs
  Rem XY_pairs(ix (1 to N_of_Z_Pairs).ID_1 holds the point ID
  Rem ColIDPt(ix (1 to N_all_GCP_TIE_ELEV)).Pt_ID holds the point ID and columns for it in A
    ID1 = 0: ID2 = 0
    For mx = 1 To Num_Of_GCPS + Num_Of_Tie_Points + Num_Of_Elev_Points
     If Gnd_obs(mx).Point = XY_pairs(kx).ID_1 Then
       ID1 = mx
       col1 = ColIDPt(mx).Y_ID
     End If
     If Gnd_obs(mx).Point = XY_pairs(kx).ID_2 Then
       ID2 = mx
       col2 = ColIDPt(mx).Y_ID
     End If
    Next mx
    If ID1 = 0 Or ID2 = 0 Then MsgBox ("Cannot find data for XY-constrained tie points")
    l(Row + kx) = (Gnd_obs(ID1).y - Gnd_obs(ID2).y) / 10 ^ 6
    P(Row + kx) = ((1 / (0.001) ^ 2)) '/ 10 ^ 6
    Print #11, Format$(Row + kx, "#") & " " & Format$(col1, "#") & " " & Format$(-1, "#.00")
    Print #11, Format$(Row + kx, "#") & " " & Format$(col2, "#") & " " & Format$(1, "#.00")
    NofNonZero = NofNonZero + 2
  Next kx

Rem Print the files
Close (11)
Close (1)
Rem ******************
Rem MATLAB-code
'B=spalloc(10720,3599,120000);
'load c:\apu\a_txt.txt
'B=spconvert(a_txt);

'fid = fopen('c:\apu\l_txt.txt','r');
'[l,count]=fscanf(fid,'%f',[10720]);
'fclose('all')

'fid = fopen('c:\apu\weigths.txt','r');
'[P,count]=fscanf(fid,'%f',[10720]);
'fclose('all')
'P=sparse(P);
'N=sparse(diag(P,0));
'c = B '*N*l;
'x=(B'*N*B)\C;

'fid = fopen('c:\apu\corr1.txt','w');
'count = fprintf(fid,'%.14f \r\n',x)
'fclose('all')

 Call Print_Normal_Matrix_and_Vector

Dim Cols As Long
Dim Rows As Long
'Rows = 2 * Num_Of_Image_Obs + 6 * Num_Of_GPSIMU + 2
Rows = 2 * Num_Of_Image_Obs + 6 * Num_Of_GPSIMU + 3 * Num_Of_Tie_Points + Num_Of_Z_Pairs + 2 * Num_Of_XY_Pairs
Cols = 6 * Num_Of_Images + 3 * Num_Of_Tie_Points
Open "C:\data\Matlab.txt" For Output As 1
Print #1, Rows, Cols, NofNonZero
Close (1)

Open "c:\data\weigths.txt" For Output As 1
For i = 1 To UBound(P) ' (Num_Of_Image_Obs * 2 + 6 * Num_Of_GPSIMU + Num_Of_Z_Pairs + 2 * Num_Of_XY_Pairs) ' 2)
 Print #1, Format$(P(i), "0.00000000000")
Next i
Close (1)


RMSE = (RMSE / (Num_Of_Image_Obs * 2 - 3 * Num_Of_Tie_Points - Num_Of_Images * 1)) ^ 0.5

apu = MsgBox("Files written, RMSE is now : " & Format$(10 ^ 6 * RMSE, "#.00 um") & " MIN errors: " & Format$(10 ^ 6 * min_x, "#.0 um ") & "," & Format$(10 ^ 6 * min_y, "#.0 um ") & "MAX errors: " & Format$(10 ^ 6 * max_x, "#.0 um ") & "," & Format$(10 ^ 6 * max_y, "#.0 um ") & " | Calculate correction vector x or leave solution as is. Continue with MATLAB?", vbYesNo)


If apu = 7 Then Exit Sub

MsgBox ("OK, now calling Matlab routines in the dll.")

Form1.MousePointer = 13

DoEvents
apu = MYFUNC_MATLABCALL(CDbl(1#))
Form1.MousePointer = 1
End Sub


Private Sub Calculate_Space_intersection_Click()

Rem Given the solution for the camera parameters, calculate the object (3D) coordi-
Rem nates for the Ground Control Points and corresponding residuals.

Rem Loop thru the list of GCPs and find the image observations for them.
Rem With known exterior orientation parameters solve the space intersection problem
Rem by minimizing squared observation errors.
Rem Calculate the errors with respect to the given coordinates

Dim i As Integer, j As Integer, k As Integer, n As Integer
Dim ix As Integer, jx As Integer, kx As Integer, lx As Integer, mx As Integer
Dim nx As Integer, num As Integer, ox As Integer, px As Integer
Dim x_ini As Double, y_ini As Double, z_ini As Double
Dim dx_dU_K As Double, dy_dU_K As Double, dx_dV_K As Double, dy_dV_K As Double
Dim dx_dW_K As Double, dy_dW_K As Double, dx As Double, dy As Double
Dim det_D As Double


ReDim el(1 To 4) As Double
ReDim delta(1 To 3) As Double

ReDim cam(1 To 2 * IMA_NUM) As Integer       ' numbers of cameras involved for an obs / point
ReDim iobs(1 To 2 * IMA_NUM) As Integer      ' numbers of obs for 3D point in calculation stored in this array
ReDim gobs(1 To 2 * IMA_NUM) As Integer      '
ReDim aa(1 To 2 * IMA_NUM, 1 To 3) As Double ' coefficient Matrix
ReDim BB(1 To 3, 1 To 2 * IMA_NUM) As Double ' coefficient Matrix ' TRANSPOSE OF AA
ReDim CC(1 To 3, 1 To 3) As Double    ' Normal Matrix BB*AA
ReDim DD(1 To 3, 1 To 3) As Double    ' Inverse of Normal Matrix BB*AA
ReDim EE(1 To 2, 1 To 2) As Double
ReDim GG(1 To 3, 1 To 2 * IMA_NUM) As Double
ReDim LL(1 To 2 * IMA_NUM) As Double

Rem Errors are printed into an ascii file

Open "c:\data\XYZ_errors.txt" For Output As 10

For i = 1 To Num_Of_GCPS + Num_Of_Elev_Points

If Gnd_obs(i).Type = 1 Or Gnd_obs(i).Type = 2 Then
  Rem a GCP was found
  k = 0
  Rem search for it's image observations
  For j = 1 To Num_Of_Image_Obs
   If Gnd_obs(i).Point = Ima_obs(j).Point Then
     Rem image obs for the GCP was found
     k = k + 1
     Rem Update indeces
     cam(k) = Ima_obs(j).image
     iobs(k) = j
     gobs(k) = i
   End If
  Next j
  
  If k < 2 Then
    Rem Space intersection requires at least two rays to intersect
    MsgBox ("There is a GCP for which there is < 2 observations!")
    GoTo Next_GCP
  End If
  
  Rem Get the field measured object coordinates
  
  x_ini = Gnd_obs(i).x + (Rnd - 0.5) * 2
  y_ini = Gnd_obs(i).y + (Rnd - 0.5) * 2
  z_ini = Gnd_obs(i).z + (Rnd - 0.5) * 2
  
  Rem there are k observations, image numbers are stored in cam() and obs number in obs()
  Rem the coefficient matrix AA will have obs * 2 rows and 3 columns
  
  Rem Start the iteration process, allow at max MAX_ITERATIONS
  For m = 1 To MAX_ITERATIONS
   Rem go thru all observations
   For n = 1 To k
    Rem For each observation calculate the differential quotients & residual
    Call Calc_dX_dY_dZ_dx_dy(iobs(n), gobs(n), cam(n), x_ini, y_ini, z_ini, dx_dU_K, dy_dU_K, dx_dV_K, dy_dV_K, dx_dW_K, dy_dW_K, dx, dy)
    Rem Collect coefficient Matrix AA and residual vector LL, recall U=X, V=Y, W=Z
    
    Rem residual vector
    LL(2 * n - 1) = dx
    LL(2 * n) = dy
    Rem Matrix A
    Rem x-row
    aa(2 * n - 1, 1) = dx_dU_K
    aa(2 * n - 1, 2) = dx_dV_K
    aa(2 * n - 1, 3) = dx_dW_K
    Rem y-row
    aa(2 * n, 1) = dy_dU_K
    aa(2 * n, 2) = dy_dV_K
    aa(2 * n, 3) = dy_dW_K
   Next n

Rem Solve corrections and update X_ini, Y_ini and Z_ini, continue untill corrections are small enough
Rem BB = Transpose(AA)  size(AA) = 2n x 3, size(BB) = 3 x 2n

    For ix = 1 To 3
     For jx = 1 To 2 * k
      BB(ix, jx) = aa(jx, ix)
     Next jx
    Next ix

Rem Multiply to get Normal Matrix (AA'*AA) that is CC= BB*AA (3 x 3)
 
For ix = 1 To 3
 For jx = 1 To 3
   For kx = 1 To 2 * k
    CC(ix, jx) = CC(ix, jx) + BB(ix, kx) * aa(kx, jx)
     ' 3 x 3       3 x 3        3 x 4    4 x 3
   Next kx
  Next jx
 Next ix
 
Rem Find inverse of CC using Cramer's rule, output the inverse in DD = inv(C)

det_D = det_cal3(CC())

For ix = 1 To 3
 For jx = 1 To 3
  num = 0
   For kx = 1 To 3
    For lx = 1 To 3
     mx = kx
     nx = lx
     Rem Choose elements of subdeterminants
     If lx = jx Then GoTo bypasscolumn
     If kx = ix Then GoTo bypassrow
     num = num + 1
     Rem by columns
     el(num) = CC(kx, lx)

bypasscolumn:
     Next lx
bypassrow:
    Next kx
    Rem Form the 2x2 submatrix
    EE(1, 1) = el(1):     EE(1, 2) = el(2):   EE(2, 1) = el(3):   EE(2, 2) = el(4)
    
    DD(jx, ix) = (1 / det_D) * det_cal2(EE())
    
    If (jx + ix) Mod 2 <> 0 Then
      DD(jx, ix) = -DD(jx, ix)
    End If
  
  Next jx
 Next ix
 
 Rem DD is inv(AA'*AA), compute GG() = inv(AA'*AA)*AA'
 Rem Remember AA' = BB()
 
 For ix = 1 To 3
  For jx = 1 To 2 * k
    For kx = 1 To 3
     GG(ix, jx) = GG(ix, jx) + DD(ix, kx) * BB(kx, jx)
Rem     3 x 2n      3 x 2n       3 x 3     3 x 2n
    Next kx
   Next jx
  Next ix

Rem All that is left is to multiply with the residual-vector, LL
Rem Corrections go the array delta()
 
 For ix = 1 To 3
  For jx = 1 To 2 * k
    delta(ix) = delta(ix) + GG(ix, jx) * LL(jx)
Rem    3 x 1      3 x 1       3 x 2n     2n x 1
  Next jx
 Next ix
 
 Rem The corrections are (X,Y,Z)
  dU = delta(1): dV = delta(2):  dW = delta(3)

Rem Zero all elements in matrices AA,BB,GG
For ox = 1 To IMA_NUM * 2
 For px = 1 To 3
    aa(ox, px) = 0:  BB(px, ox) = 0:      GG(px, ox) = 0
 Next px
Next ox

delta(1) = 0: delta(2) = 0: delta(3) = 0
EE(1, 1) = 0: EE(1, 2) = 0: EE(2, 1) = 0: EE(2, 2) = 0
CC(1, 1) = 0: CC(1, 2) = 0: CC(1, 3) = 0: CC(2, 1) = 0: CC(2, 2) = 0: CC(2, 3) = 0: CC(3, 1) = 0: CC(3, 2) = 0: CC(3, 3) = 0
DD(1, 1) = 0: DD(1, 2) = 0: DD(1, 3) = 0: DD(2, 1) = 0: DD(2, 2) = 0: DD(2, 3) = 0: DD(3, 1) = 0: DD(3, 2) = 0: DD(3, 3) = 0

Rem stop iteration when correction vector change is less than ITE_STOP
If (CStr((dU ^ 2 + dV ^ 2 + dW ^ 2) ^ 0.5)) < ITE_STOP Then GoTo iteration_stop

x_ini = x_ini + dU
y_ini = y_ini + dV
z_ini = z_ini + dW
  
Rem Next iteration round
Next m

iteration_stop:

Print #10, "Point: " & CStr(Gnd_obs(i).Point) & " ," & CStr(Gnd_obs(i).x) & ", " & Format$(Gnd_obs(i).x - x_ini, "#.00") & " , " & CStr(Gnd_obs(i).y) & ", " & Format$(Gnd_obs(i).y - y_ini, "#.00") & " ," & CStr(Gnd_obs(i).z) & " ," & Format$(Gnd_obs(i).z - z_ini, "#.00")

Rem If it is a GCP if-block
End If
Rem Next point
Next_GCP: Next i
Close (10)
Exit Sub
Error_in_GCP_space_intersection:
MsgBox ("An error occurred in sub Calculate_Space_intersection_Click() ")
Close (10)
End Sub

Private Sub Label1_Click(Index As Integer)

End Sub

Private Sub Open_obs_ini_Click()
Dim j As Integer

'On Error GoTo error_in_reading_obs_ini

Rem *****************************************************************
Rem Read a file that describes the task
Rem {number of images, Ground Control Points, Tie points, Image observations}
' ******************************************

CommonDialog1.DialogTitle = "File with task description"
CommonDialog1.FileName = "*.*"
CommonDialog1.Action = 1
Open CommonDialog1.FileName For Input As 1
'Exit Sub

Input #1, Num_Of_Images, Num_Of_Tie_Points, Num_Of_Image_Obs
List1.AddItem "Num of images: " & CStr(Num_Of_Images) & " " & " Tie Points: " & CStr(Num_Of_Tie_Points) & " Image Obs: " & CStr(Num_Of_Image_Obs)
Close (1)

Rem *****************************************************************
Rem Read a file with image observations
Rem each record shows {point number, image number, x & y coordinates}
Rem *****************************************************************
CommonDialog1.DialogTitle = "File with Image observations"
CommonDialog1.FileName = "*.*"
CommonDialog1.Action = 1
Open CommonDialog1.FileName For Input As 1
For j = 1 To Num_Of_Image_Obs   ' read the observations
  Input #1, Ima_obs(j).image, Ima_obs(j).weight, Ima_obs(j).Point, Ima_obs(j).x, Ima_obs(j).y
  List1.AddItem "Obs: " & CStr(j) & " , " & Ima_obs(j).weight & " , " & CStr(Ima_obs(j).Point) & ", " & CStr(Ima_obs(j).image) & ", " & Format$(Ima_obs(j).x, "0.0000000") & " , " & Format$(Ima_obs(j).y, "0.0000000")
Next j
Close (1)


Rem ******************************************************************
Rem Read a file with initial / fixed values for the object coordinates
Rem of GCP and Tie Points
Rem ******************************************************************

CommonDialog1.DialogTitle = "File with GCP & Tie POint X,Y,Z data"
CommonDialog1.FileName = "*.*"
CommonDialog1.Action = 1
Open CommonDialog1.FileName For Input As 1
jx = 6 * Num_Of_Images + 1
For j = 1 To (Num_Of_Tie_Points)
 Input #1, Gnd_obs(j).Point, Gnd_obs(j).Type, Gnd_obs(j).wX, Gnd_obs(j).WY, Gnd_obs(j).WZ, Gnd_obs(j).x, Gnd_obs(j).y, Gnd_obs(j).z
 Gnd_obs(j).x_ini = Gnd_obs(j).x
 Gnd_obs(j).y_ini = Gnd_obs(j).y
 Gnd_obs(j).z_ini = Gnd_obs(j).z
 
 
 If Gnd_obs(j).Type = 2 Or Gnd_obs(j).Type = 0 Then  ' Here starts Z-points / tiepoints
  ix = ix + 1
  ColIDPt(j).Pt_ID = Gnd_obs(j).Point
   If Gnd_obs(j).Type = 0 Then
    jx = jx + 3
    ColIDPt(j).X_ID = jx - 3
    ColIDPt(j).Y_ID = jx - 2
    ColIDPt(j).Z_ID = jx - 1
   End If
  End If
 Rem If Gnd_obs(j).Point <> j Then MsgBox ("Check the numbering of the GCP/Tie points")
 List1.AddItem "Obs: " & CStr(j) & " , " & CStr(Gnd_obs(j).Point) & " , " & CStr(Gnd_obs(j).Type) & " , " & Format$(Gnd_obs(j).x, "#.00") & " , " & Format$(Gnd_obs(j).y, "#.00") & " , " & Format$(Gnd_obs(j).z, "#.00")
Next j
Close (1)

Rem ****************************************************************************
Rem Read initial values for the camera parameters, omega, phi, kappa, Xo, Yo, Zo, camname
Rem ****************************************************************************

CommonDialog1.DialogTitle = "File with initial camera parameters"
CommonDialog1.FileName = "*.*"
CommonDialog1.Action = 1
Open CommonDialog1.FileName For Input As 1
'Open "e:\kulmat.txt" For Output As 10
Close (10)
Num_Of_GPSIMU = 0
For j = 1 To Num_Of_Images
 Input #1, Cam_obs(j).image, Cam_obs(j).Type, Cam_obs(j).c, Cam_obs(j).omega, Cam_obs(j).phi, _
 Cam_obs(j).kappa, Cam_obs(j).x0, Cam_obs(j).y0, Cam_obs(j).z0, _
 Cam_obs(j).womega, Cam_obs(j).wphi, Cam_obs(j).wkappa, _
 Cam_obs(j).wx0, Cam_obs(j).wy0, Cam_obs(j).wz0, Cam_obs(j).Camname
 If Cam_obs(j).Type = 1 Then
 Num_Of_GPSIMU = Num_Of_GPSIMU + 1
 Cam_obs(j).omega_IMU = Cam_obs(j).omega:   Cam_obs(j).phi_IMU = Cam_obs(j).phi:  Cam_obs(j).kappa_IMU = Cam_obs(j).kappa
 Cam_obs(j).X0_GPS = Cam_obs(j).x0: Cam_obs(j).Y0_GPS = Cam_obs(j).y0: Cam_obs(j).Z0_GPS = Cam_obs(j).z0
 End If
  List1.AddItem "Obs: " & CStr(j) & " , " & CStr(Cam_obs(j).image) & " , " & Format$(Cam_obs(j).omega, "#.00000000") & " , " & Format$(Cam_obs(j).phi, "#.00000000") & " , " & Format$(Cam_obs(j).kappa, "#.00000000") & " , " & Format$(Cam_obs(j).x0, "#.00000000") & " , " & Format$(Cam_obs(j).y0, "#.00000000") & " , " & Format$(Cam_obs(j).z0, "#.00000000") & " , " & Cam_obs(j).Camname
Next j
Close (1)

CommonDialog1.DialogTitle = "File with ids for Z-constrained tie points"
CommonDialog1.FileName = "*.*"
CommonDialog1.Action = 1
Open CommonDialog1.FileName For Input As 1
ix = 1
Do Until EOF(1)
 Input #1, Z_pairs(ix).ID_1, Z_pairs(ix).ID_2
 List1.AddItem "Z-pair ids: " & CStr(Z_pairs(ix).ID_1) & "," & CStr(Z_pairs(ix).ID_2)
 ix = ix + 1
Loop
Num_Of_Z_Pairs = ix - 1
Close (1)

CommonDialog1.DialogTitle = "File with ids for XY-constrained tie points"
CommonDialog1.FileName = "*.*"
CommonDialog1.Action = 1
Open CommonDialog1.FileName For Input As 1
ix = 1
Do Until EOF(1)
 Input #1, XY_pairs(ix).ID_1, XY_pairs(ix).ID_2
 List1.AddItem "XY-pair ids: " & CStr(XY_pairs(ix).ID_1) & "," & CStr(XY_pairs(ix).ID_2)
 ix = ix + 1
Loop
Num_Of_XY_Pairs = ix - 1
Close (1)

Close (1)

ReDim l(1 To Num_Of_Image_Obs * 2 + 6 * Num_Of_GPSIMU + 3 * Num_Of_Tie_Points + 2 * Num_Of_XY_Pairs + Num_Of_Z_Pairs) As Double

Exit Sub

Rem **************
Rem Error handling
Rem **************
error_in_reading_obs_ini:
MsgBox ("An I/O error occurred in reading the input files, check the files!")

End Sub


Private Sub Output_Solution_Click()

Rem This Routine prints the unknwons of the problem to an ascii-file

Dim j As Integer
Dim capu As String

On Error GoTo error_in_printing

CommonDialog1.DialogTitle = "File for outputting the unknowns"
CommonDialog1.FileName = "*.txt"
CommonDialog1.Action = 2
Open CommonDialog1.FileName For Output As 1

Rem Camera Parameters
Rem Using string capu, "print" to it first (loop and collect)
For j = 1 To Num_Of_Images
 capu = Format$(Cam_obs(j).image, "#0") & ","
 capu = capu & Format$(Cam_obs(j).omega, "#.0000000000") & ","
 capu = capu & Format$(Cam_obs(j).phi, "#.0000000000") & ","
 capu = capu & Format$(Cam_obs(j).kappa, "#.0000000000") & ","
 capu = capu & Format$(Cam_obs(j).x0, "#.00000000") & ","
 capu = capu & Format$(Cam_obs(j).y0, "#.00000000") & ","
 capu = capu & Format$(Cam_obs(j).z0, "#.00000000")
 Rem Print capu string & make it empty after that.
 Print #1, capu
 capu = ""
Next j

Rem Tie & Control points
For j = 1 To Num_Of_Tie_Points
Print #1, Format$(Gnd_obs(j).Point, "##0") & "," & Format$(Gnd_obs(j).Type, "0") & "," & Format$(Gnd_obs(j).x, "#.000") & "," & Format$(Gnd_obs(j).y, "#.000") & "," & Format$(Gnd_obs(j).z, "#.000")
Next j

Rem Notify
MsgBox ("Results written in file " & CommonDialog1.FileName)
Close (1)
Exit Sub
error_in_printing:
Close (1)
MsgBox ("An error occurred!")
End Sub

Private Sub read_corr_vector_Click()

Rem ******************************************************************************
Rem Reads the correction vector, it consists of Num_Of_Images x 6 rows of camera
Rem parameters: delta(omega,phi,kappa,X0,Y0,Z0) followed by Number_of_Tie_Points x 3
Rem rows of point-location parameters delta(X, Y, Z) for the tie points

Rem They will be stored in the correction vector, CORR_VECT, to be added elsewhere

' On Error GoTo error_in_reading_corr_vector

CommonDialog1.DialogTitle = "Filename for correction vector file"
CommonDialog1.FileName = "*.txt"
CommonDialog1.Action = 1
Open CommonDialog1.FileName For Input As 1

Rem Read the data & close thereafter the file
For j = 1 To (6 * Num_Of_Images + Num_Of_Tie_Points * 3)
 Input #1, CORR_VECT(j)
 CORR_VECT(j) = 1 * CORR_VECT(j)
Next j

Close (1)

Rem Update the list-box
For j = 1 To 6 * Num_Of_Images Step 6
 List1.AddItem " , " & Format$(CORR_VECT(j), "#.000000") & " , " & Format$(CORR_VECT(j + 1), "#.000000") & " , " & Format$(CORR_VECT(j + 2), "#.000000") & " , " & Format$(CORR_VECT(j + 3), "#.000") & " , " & Format$(CORR_VECT(j + 4), "#.000") & " , " & Format$(CORR_VECT(j + 5), "#.000")
Next j
For j = Num_Of_Images * 6 + 1 To (Num_Of_Images * 6 + Num_Of_Tie_Points * 3) Step 3
 List1.AddItem " , " & Format$(CORR_VECT(j), "#.000") & " , " & Format$(CORR_VECT(j + 1), "#.000") & " , " & Format$(CORR_VECT(j + 2), "#.000")
Next j

Exit Sub
Rem Error -handling
error_in_reading_corr_vector:
MsgBox ("Error in reading the correction vector!, Check the file")

End Sub


Private Sub Write_normal_matrix_vector_Click()

End Sub


